// ignore_for_file: must_be_immutable

library flutter_animated_splash;

import 'dart:async';
import 'dart:core';

import 'package:flutter/material.dart';

class Splashanimatedscreen extends StatefulWidget {
  final Color backgroundColor;
  dynamic animation;
  final double logoSize;
  final Widget child;
  final int durationInSeconds;
  final Widget? navigator;
  final Future<Object>? futureNavigator;
  final Curve curve;
  // ignore: use_key_in_widget_constructors
  Splashanimatedscreen({
    //this.curve = Curves.easeInBack,
    required this.child,
    this.curve = Curves.easeInQuint,
    this.animation,
    this.futureNavigator,
    this.navigator,
    this.durationInSeconds = 3,
    this.logoSize = 300,
    this.backgroundColor = Colors.white,
  });

  @override
  _SplashanimatedscreenState createState() => _SplashanimatedscreenState();
}

class _SplashanimatedscreenState extends State<Splashanimatedscreen> {
  @override
  void initState() {
    super.initState();

    Timer(
      const Duration(seconds: 3),
      () => Navigator.push(
        context,
        PageRouteBuilder(
          pageBuilder: (context, animation, animationTime) {
            return widget.navigator as Widget;
          },
          transitionDuration: const Duration(milliseconds: 2000),
          transitionsBuilder: (context, animation, animationTime, child) {
            animation = CurvedAnimation(parent: animation, curve: widget.curve);
            return ScaleTransition(
              alignment: Alignment.center,
              scale: CurvedAnimation(
                parent: animation,
                curve: Interval(
                  0.00,
                  0.50,
                  curve: widget.curve,
                ),
              ),
              child: widget.navigator,
            );

            //FadeTransition(opacity: animation, child: widget.navigator);
          },
        ),
      ),
    );
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: widget.backgroundColor,
      body: Center(
        child: Stack(
          children: [
            widget.child,
          ],
        ),
      ),
    );
  }
}
